function adfwrite(filters,nlsp,fs,filename)

%function adfwrite(filters,nlsp,fs,filename)
%
% Writes a matrix of FIR shelving filters for modified high-frequency Ambisonics 
% decoding to a file format compatible with ambidec.
%
% Parameters:
%   'filters'...... the matrix of FIR filters returned from 'ambimodgains'
%   'nlsp'......... number of loudspeakers
%   'fs'........... sampling frequency [Hz]
%   'filename'..... descriptive name, excluding file ending
%
% - Brd Stfringsdal 2006 -

% add file type
filename = [filename '.adf'];
fid = fopen(filename,'w');

[filterlength nfilters] = size(filters);
order = nfilters-1;

% write header
filetypecode = 'ADF';
fwrite(fid, filetypecode, 'char');
fwrite(fid, fs, 'int');
fwrite(fid, order, 'int');
fwrite(fid, filterlength, 'int');
fwrite(fid, nlsp, 'int');

% content
fwrite(fid, filters, 'float');

fclose(fid);