function gm = maxre(M,K)

%function gm = maxre(m,k)
%
% Calculates maximum energy vector HOA decoder weights. 'm' is 
% Ambisonics order. Basic decoding is enforced up to order 'k'
%
% 'gm' is a row vector of length 'm'+1 holding gain factors for
% the respective modes
%
% - Brd Stfringsdal 2006 -

% find optimal gamma 
f = @(gamma)(2*K+1)*cos((2*M-2*K+3)*gamma)-4*K*cos((2*M-2*K+2)*gamma)+...
    (2*K-1)*cos((2*M-2*K+1)*gamma)-4*K*cos(gamma)+4*K;
% gamma resolution
dp = 10^-3;
param = dp:dp:pi/2;
% find first zeros after gamma = 0
fvals = f(param);
fsign = sign(fvals);
zind = find(fsign(2:end)~= fsign(1:end-1),1)+1;
zero = param(zind);

% orders
m = 0:M;

% modal gains
gm = [ones(1,K+1)*sin((M-K+1)*zero) sin((M-m(K+2:end)+1)*zero)];

