/* 
 * This file is part of ambitools.
 * Copyright (C) 2006-2007 Centre for Quantifiable Quality of Service in
 * Communication Systems, Norwegian University of Science and Technology.
 *
 * ambitools is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ambitools is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ambitools; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef _decodersettingswindow_h
#define _decodersettingswindow_h

#include <gtkmm/comboboxtext.h>
#include <gtkmm/spinbutton.h>
#include <gtkmm/window.h>
#include "AmbisonicsDecoderModel.hpp"
#include "View.hpp"
#include "Widgets.hpp"

class DecoderSettingsWindow : public Gtk::Window, public View {
private:
	NormalizationComboBox _combo_norm;
	Gtk::SpinButton _btn_regparm;
	AmbisonicsDecoderModel& _dec;
	void on_normalization_changed();
	void on_regparm_changed();
public:
	DecoderSettingsWindow(AmbisonicsDecoderModel& enc);
	virtual void Notify(int what);
};

#endif

