/* 
 * This file is part of ambitools.
 * Copyright (C) 2006-2007 Centre for Quantifiable Quality of Service in
 * Communication Systems, Norwegian University of Science and Technology.
 *
 * ambitools is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ambitools is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ambitools; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef _encodersettingswindow_h
#define _encodersettingswindow_h

#include <gtkmm/adjustment.h>
#include <gtkmm/comboboxtext.h>
#include <gtkmm/spinbutton.h>
#include <gtkmm/window.h>
#include "AmbisonicsEncoderModel.hpp"
#include "View.hpp"
#include "Widgets.hpp"

class EncoderSettingsWindow : public Gtk::Window, public View {
private:
	NormalizationComboBox _combo_norm;
	Gtk::Adjustment _adj_maxsourcegain, _adj_halfpointtime;
	Gtk::CheckButton _btn_distance;
	Gtk::CheckButton _btn_delay;
	Gtk::CheckButton _btn_nfc;
	Gtk::CheckButton _btn_nfc_highpass;
	Gtk::SpinButton _btn_maxsourcegain;
	Gtk::SpinButton _btn_halfpointtime;
	AmbisonicsEncoderModel& _enc;
	void on_normalization_changed();
	void on_distance_clicked();
	void on_delay_clicked();
	void on_nfc_clicked();
	void on_nfc_highpass_clicked();
	void on_maxsourcegain_changed();
	void on_halfpointtime_changed();
public:
	EncoderSettingsWindow(AmbisonicsEncoderModel& enc);
	virtual void Notify(int what);
};

#endif

