/* 
 * This file is part of ambitools.
 * Copyright (C) 2006-2007 Centre for Quantifiable Quality of Service in
 * Communication Systems, Norwegian University of Science and Technology.
 *
 * ambitools is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ambitools is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ambitools; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef _ldc_h
#define _ldc_h

#include <vector>
#include "AudioProcessor.hpp"
#include "NFCFilter.hpp"

class LDC : public AudioProcessor {
private:
	std::vector<NFCFilter> _filters;
	bool _is3d;
	unsigned _order;
	double _R1, _R2;
public:
	LDC();
	void SetDistances(double R1, double R2);
	void SetIs3D(bool is3d);
	void SetOrder(unsigned order);
	virtual void Process(float** inputs, float** outputs, unsigned num);
	virtual void SetSampleRate(unsigned sr);
	virtual size_t GetNumInputs() const
	{
		return _filters.size() + 1; // 0th order component has no filter entry
	}
	virtual size_t GetNumOutputs() const
	{
		return _filters.size() + 1;
	}
	virtual ~LDC()
	{
	}
};

#endif

