/* 
 * This file is part of ambitools.
 * Copyright (C) 2006-2007 Centre for Quantifiable Quality of Service in
 * Communication Systems, Norwegian University of Science and Technology.
 *
 * ambitools is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ambitools is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ambitools; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef _ldcgui_h
#define _ldcgui_h

#include <gtkmm/actiongroup.h>
#include <gtkmm/adjustment.h>
#include <gtkmm/checkbutton.h>
#include <gtkmm/scale.h>
#include <gtkmm/spinbutton.h>
#include <gtkmm/uimanager.h>
#include <gtkmm/window.h>
#include "JACKInterface.hpp"
#include "LDC.hpp"

class LDCGUI : public Gtk::Window {
private:
	static Glib::ustring _menu_info;
	Glib::RefPtr<Gtk::ActionGroup> _actiongroup;
	Glib::RefPtr<Gtk::UIManager> _uimanager;
	Gtk::Adjustment _adj_order;
	Gtk::Adjustment _adj_radius1, _adj_radius2;
	Gtk::SpinButton _btn_order;
	Gtk::CheckButton _btn_3d;
	Gtk::HScale _sld_radius1, _sld_radius2;
	Gtk::SpinButton _btn_radius1, _btn_radius2;
	Gtk::CheckButton _btn_inf1;
	JACKInterface& _snd;
	LDC _ldc;
	
	void on_order_changed();
	void on_3d_clicked();
	void on_radius_changed();
	void on_inf_clicked();
	void on_quit();
	void on_route_inputs();
	void on_route_outputs();
	void on_view_aboutbox();
public:
	LDCGUI(JACKInterface& ai);
};

#endif
