/* 
 * This file is part of ambitools.
 * Copyright (C) 2006-2007 Centre for Quantifiable Quality of Service in
 * Communication Systems, Norwegian University of Science and Technology.
 *
 * ambitools is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ambitools is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ambitools; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef _matrix_h
#define _matrix_h

#include "align16_allocator.h"
#include <vector>
#include "boost/numeric/ublas/matrix.hpp"

using namespace boost::numeric::ublas;

typedef matrix< float, row_major, unbounded_array<float,
    align16_allocator<float> > > Matrix;

typedef matrix< double, row_major, unbounded_array<double,
    align16_allocator<double> > > DoubleMatrix;

#endif

