/* 
 * This file is part of ambitools.
 * Copyright (C) 2006-2007 Centre for Quantifiable Quality of Service in
 * Communication Systems, Norwegian University of Science and Technology.
 *
 * ambitools is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * ambitools is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with ambitools; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef _model_h
#define _model_h

#include <list>
#include "View.hpp"

typedef std::list<View*> ViewList;

class Model {
	ViewList _views;
public:
	void AddView(View* v)
	{
		_views.push_back(v);
		v->Notify(0); // Tell view to update everything
	}
	
	void RemoveView(View* v)
	{
		_views.remove(v);
	}
	
	// Default is to update all controls
	void NotifyViews(int what = 0)
	{
		for (ViewList::iterator i = _views.begin(); i != _views.end(); ++i) {
			View* v = *i;
			v->Notify(what);
		}
	}
};

#endif

